/*
	File:		DocumentWindow.cp

	Contains:	An abstract base class for document-backed windows
				
	Written by: Dave Falkenburg
	
	Copyright:	 1994-95 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
		 <1>	  1/3/95	DRF		First checked in.
 */

#include "DocumentWindow.h"

TDocumentWindow::TDocumentWindow(TDocument *backingDocument)
	{
	fDocument = backingDocument;
	}



void
TDocumentWindow::Activate(Boolean activating)
	{
	//	Make sure we keep the document list in the same order as the windowlist
	
	if (activating)
		fDocument->BringDocumentToFront();

	//	Should really add activation routines for enabling/disabling menus

	}



Boolean
TDocumentWindow::Close()
	{
	return fDocument->Close(false);
	}


Boolean
TDocumentWindow::DoMenuCommand(MenuCommandID menuCommand)
	{
	return fDocument->DoMenuCommand(menuCommand);
	}
