/*
	File:		SprocketConditionals.h

	Contains:	Defines used to control what capabilities are built

	Written by: Dave Falkenburg

	Copyright:	 1994 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
		 <1>	11/12/94	DRF		First checked in.
		 <3>	  9/9/94	DRF		Conditionalize AOCE support. Assume just a base system for now.
		 <2>	  9/1/94	DRF		We only run under System 7.0 or later. NOTE: This typically
									requires rebuilding precompiled headers.
 */

#ifndef	_BUILDCONDITIONALS_
#define	_BUILDCONDITIONALS_

#define SystemSevenFiveOrLater		0	// For the moment
#define	SystemSevenOrLater			1

#define STRICT_CONTROLS 			0
#define STRICT_WINDOWS 				0
#define STRICT_MENUS 				1

#define OLDROUTINENAMES				0	// We're up-to-date
#define OLDROUTINELOCATIONS			0
#define CGLUESUPPORTED				0

#ifndef	qDebug
#define	qDebug						0
#endif

#ifndef	qAOCEAware
#define	qAOCEAware					0
#endif

#ifndef	qUseQuickDrawGX
#define	qUseQuickDrawGX				0
#define	qRequireDrawGX				0
#define	qUseQuickDrawGXDebugging	0
#endif

#ifndef	qRequireThreadManager
#define	qRequireThreadManager		0
#endif

#ifndef	qInlineInputAware
#define	qInlineInputAware			0
#endif

//#if	qUseQuickDrawGX
//	Tell QuickDrawGX that we use universal headers
//#define	ppcinterfaces		1
//#endif

#endif
